(function() {
    
    var overlaysArray = [];
    var overlayParentsArray = [];
    
    function getPos(el) {
        var xPos = 0;
        var yPos = 0;
        
        while (el) {
            if (el.tagName == "BODY") {
                // deal with browser quirks with body/window/document and page scroll
                var xScroll = el.scrollLeft || document.documentElement.scrollLeft;
                var yScroll = el.scrollTop || document.documentElement.scrollTop;
                
                xPos += (el.offsetLeft + el.clientLeft);
                yPos += (el.offsetTop + el.clientTop);
            } else {
                // for all other non-BODY elements
                xPos += (el.offsetLeft + el.clientLeft);
                yPos += (el.offsetTop + el.clientTop);
            }
            
            el = el.offsetParent;
        }
        return { x: xPos, y: yPos };
    }
 
    function getCurrentDomain() {
        return window.location.hostname.split('.').slice(-2).join('.').toLowerCase();
    }
    
    function isDefined(obj) {
        return (obj && typeof obj != 'undefined');
    }
    
    function handleTubesOrientationChange() {
        var domain = getCurrentDomain();
        if (domain == "xvideos.com" || domain == "xnxx.com") {
            setOverlayLayoutXVideos();
        }
        else if (domain == "drtuber.com") {
            setOverlayLayoutDrTuber();
        }
        else if (domain == "upornia.com") {
            setOverlayLayoutUPornia();
        }
        else if (domain == "youjizz.com") {
            setOverlayLayoutYouJizz();
        }
        else if (domain == "nuvid.com") {
            setOverlayLayoutNuVid();
        }
    }
    
    
    // XVideos
 
    function parseXVideos() {
        // If we have HTML5 player object
        if (html5player && typeof html5player != 'undefined') {
            var videoUrl = html5player.url_high;
            if (isDefined(videoUrl)) {
                var hlsplayer = document.getElementById("hlsplayer");
                if (isDefined(hlsplayer)) {
                    var css = document.createElement("style");
                    css.type = "text/css";
                    css.innerHTML = ".overlayXVideos { background-color: clear; opacity: 0.8; position: absolute; z-index: 2; display: block; } .overlayVD { display: none !important; } .sdabox {display: none !important;}";
                    (document.getElementsByTagName("head")[0] || document.body).appendChild(css);

                    var overlay = document.createElement("a");
                    overlay.setAttribute("href", videoUrl);
                    overlay.setAttribute("class", "overlayXVideos");
                    
                    overlaysArray.push(overlay);
                    overlayParentsArray.push(hlsplayer);
                    setOverlayLayoutXVideos();
                    
                    document.body.appendChild(overlay);
                }
            }
        }
    }
    
    function setOverlayLayoutXVideos() {
        setTimeout(function() {
            for (var i = 0; i < overlaysArray.length; i++) {
                var overlay = overlaysArray[i];
                var overlayParent = overlayParentsArray[i];
                
                var positions = getPos(overlayParent);
                
                var video_rect = overlayParent.parentElement.getBoundingClientRect();
                if (video_rect.width == 0) {
                    video_rect = overlayParent.parentElement.getBoundingClientRect();
                }
                overlay.style.left   = positions["x"] + 'px';
                overlay.style.top    = positions["y"] + 'px';
                overlay.style.width  = video_rect.width + 'px';
                overlay.style.height = video_rect.height + 'px';
            }
        }, 400);
    }
    
    
    // GotPorn
    
    function parseGotporn() {
        var css = document.createElement("style");
        css.type = "text/css";
        css.innerHTML = ".overlayVD { transform: scale(0.6) !important; }";
        (document.getElementsByTagName("head")[0] || document.body).appendChild(css);
    }
    
    
    // DrTuber
    
    function parseDrTuber() {
        try {
            
            var videos = document.getElementsByTagName("video");
            
            var css = document.createElement("style");
            css.type = "text/css";
            css.innerHTML = ".overlayDrTuber { background-color: clear; opacity: 0.8; position: absolute; z-index: 2; display: block; } .overlayVD { display: none !important; }";
            (document.getElementsByTagName("head")[0] || document.body).appendChild(css);
            
            
            if (videos.length > 0) {
                
                var video = videos.item(0);
                
                var sources = video.getElementsByTagName("source");
                if (sources.length > 0) {
                    var videoSource = sources.item(0);
                    var urlVideo = videoSource.src;
                    
                    var timeout = 0;
                    
                    if (urlVideo.length > 0) {
                        timeout = 1000;
                    }
                    
                    setTimeout(function() {
                        
                        var videoParentObjects = new Array();
                        videoParentObjects.push(document.getElementById("play_dvd_html5"));
                        videoParentObjects.push(document.getElementsByClassName("formLink btn_download download_flv").item(0));
                        
                        for (var i = 0; i < videoParentObjects.length; i++) {
                            var obj = videoParentObjects[i];
                            
                            var overlay = document.createElement("a");
                            overlay.setAttribute("href", urlVideo);
                            overlay.setAttribute("class", "overlayDrTuber");
                            
                            overlaysArray.push(overlay);
                            overlayParentsArray.push(obj);
                            setOverlayLayoutDrTuber();
                            
                            document.body.appendChild(overlay);
                        }
                        
                        
                    }, timeout);
                }
            }
        } catch (error) {
            console.log(error);
        }
    }
    
    function setOverlayLayoutDrTuber() {
        setTimeout(function() {
            for (var i = 0; i < overlaysArray.length; i++) {
                var overlay = overlaysArray[i];
                var overlayParent = overlayParentsArray[i];
                
                var positions = getPos(overlayParent);                 
                if (positions["x"] == 0 && positions["y"] == 0) {
                    positions = getPos(overlayParent.parentElement);
                }
                
                var video_rect = overlayParent.getBoundingClientRect();
                overlay.style.left   = positions["x"] + 'px';
                overlay.style.top    = positions["y"] + 'px';
                overlay.style.width  = video_rect.width + 'px';
                overlay.style.height = video_rect.height + 'px';
            }
        }, 400);
    }
    
    
    // UPornia
    
    function parseUPornia() {
        try {
            
            var videos = document.getElementsByTagName("video");
            
            var css = document.createElement("style");
            css.type = "text/css";
            css.innerHTML = ".overlayUPornia { background-color: clear; opacity: 0.8; position: absolute; z-index: 20; display: block; } .overlayVD { display: none !important; }";
            (document.getElementsByTagName("head")[0] || document.body).appendChild(css);
            
            if (videos.length > 0) {
                var videoHolders = document.getElementsByClassName("player-holder");
                if (videoHolders.length > 0) {
                    
                    var videoHolder = videoHolders.item(0);
                    var video = videos.item(0);
                    var urlVideo = video.currentSrc;
                    var timeout = 0;
                    
                    if (urlVideo.length > 0) {
                        timeout = 1000;
                    }
                    
                    setTimeout(function() {
                        
                        var overlay = document.createElement("a");
                        overlay.setAttribute("href", urlVideo);
                        overlay.setAttribute("class", "overlayUPornia");
                        
                        overlaysArray.push(overlay);
                        overlayParentsArray.push(videoHolder);
                        setOverlayLayoutUPornia();
                        
                        document.body.appendChild(overlay);
                    }, timeout);
                }
                
            }
        } catch (error) {
            console.log(error);
        }
    }
    
    function setOverlayLayoutUPornia() {
        setTimeout(function() {
            for (var i = 0; i < overlaysArray.length; i++) {
                var overlay = overlaysArray[i];
                var overlayParent = overlayParentsArray[i];
                
                var positions = getPos(overlayParent);
                var video_rect = overlayParent.getBoundingClientRect();
                overlay.style.left   = positions["x"] + 'px';
                overlay.style.top    = positions["y"] + 'px';
                overlay.style.width  = video_rect.width + 'px';
                overlay.style.height = video_rect.height + 'px';
            }
        }, 400);
    }
    
    
    // YouJizz
    
    function parseYouJizz() {
        
        // Custom CSS
        
        var css = document.createElement("style");
        css.type = "text/css";
        css.innerHTML = ".overlayYJ { background-color: clear; opacity: 0.8; position: absolute; z-index: 2; display: block; } .overlayVD { display: none !important; }";
        (document.getElementsByTagName("head")[0] || document.body).appendChild(css);
        
        setTimeout(function() {
            
            var downloadBtn = document.getElementById("downloadButton");
            
            if (isDefined(downloadBtn)) {
                var downloadLinkObj = downloadBtn.getElementsByTagName("a");
                
                if (isDefined(downloadLinkObj) && downloadLinkObj.length > 0) {
                    var downloadUrl = downloadLinkObj.item(0).getAttribute("download");
                    if (isDefined(downloadUrl) && downloadUrl.length > 0) {
                        
                        // Video-player overlay
                        
                        var playerVideoObj = document.getElementById("yj-html5-video");
                        if (isDefined(playerVideoObj)) {
                            var overlay = document.createElement("a");
                            overlay.setAttribute("href", downloadUrl);
                            overlay.setAttribute("class", "overlayYJ");
                            
                            overlaysArray.push(overlay);
                            overlayParentsArray.push(playerVideoObj);
                        }
                        
                        // Download-button overlay
                        
                        var downloadBtnObj = document.getElementById("downloadPlayerFile");
                        if (isDefined(downloadBtnObj)) {
                            var overlayDB = document.createElement("a");
                            overlayDB.setAttribute("href", downloadUrl);
                            overlayDB.setAttribute("class", "overlayYJ");
                            
                            overlaysArray.push(overlayDB);
                            overlayParentsArray.push(downloadBtnObj);
                        }
                        
                        setOverlayLayoutYouJizz();
                        for (var i = 0; i < overlaysArray.length; i++) {
                            var overlay = overlaysArray[i];
                            document.body.appendChild(overlay);
                        }
                    }
                }
            }
        
        }, 1000);
    }
    
    function setOverlayLayoutYouJizz() {
        setTimeout(function() {
            for (var i = 0; i < overlaysArray.length; i++) {
                var overlay = overlaysArray[i];
                var overlayParent = overlayParentsArray[i];
                
                var positions = getPos(overlayParent);
                if (positions["x"] == 0 && positions["y"] == 0) {
                    positions = getPos(overlayParent.parentElement);
                }
                var videoRect = overlayParent.getBoundingClientRect();
                overlay.style.left   = positions["x"] + 'px';
                overlay.style.top    = positions["y"] + 'px';
                overlay.style.width  = videoRect.width + 'px';
                overlay.style.height = videoRect.height + 'px';
            }
        }, 400);
    }
    
    
    // NuVid
    
    function parseNuVid() {
        try {
            setTimeout(function() {
                var videos = document.getElementsByTagName("video");
                var videoPlayer = document.getElementById("play_dvd_html5");
                
                var css = document.createElement("style");
                css.type = "text/css";
                css.innerHTML = ".overlayNuVid { background-color: clear; opacity: 0.8; position: absolute; z-index: 20; display: block; } .overlayVD { display: none !important; }";
                (document.getElementsByTagName("head")[0] || document.body).appendChild(css);
                alert(2222);
                if (videos.length > 0 && isDefined(videoPlayer)) {
                    alert(1111);
                    var video = videos.item(0);
                    var urlVideo = video.currentSrc;
                    
                    var overlay = document.createElement("a");
                    overlay.setAttribute("href", urlVideo);
                    overlay.setAttribute("class", "overlayNuVid");
                    
                    overlaysArray.push(overlay);
                    overlayParentsArray.push(videoPlayer);
                    setOverlayLayoutNuVid();
                    
                    videoPlayer.appendChild(overlay);
                }
            }, 1000);
        } catch (error) {
            console.log(error);
        }
    }
    
    function setOverlayLayoutNuVid() {
        setTimeout(function() {
            for (var i = 0; i < overlaysArray.length; i++) {
                var overlay = overlaysArray[i];
                var overlayParent = overlayParentsArray[i];
                
                var video_rect = overlayParent.getBoundingClientRect();
                overlay.style.left   = '0px';
                overlay.style.top    = '0px';
                overlay.style.width  = video_rect.width + 'px';
                overlay.style.height = video_rect.height + 'px';
            }
        }, 400);
    }
    
    
    // Main script

    var shouldListenOrientationChange = false;
    var domain = getCurrentDomain();
    if (domain == "xvideos.com" || domain == "xnxx.com") {
        parseXVideos();
        shouldListenOrientationChange = true;
    }
    else if (domain == "gotporn.com") {
        parseGotporn();
    }
    else if (domain == "drtuber.com") {
        parseDrTuber();
        shouldListenOrientationChange = true;
    }
    else if (domain == "upornia.com") {
        parseUPornia();
        shouldListenOrientationChange = true;
    }
    else if (domain == "youjizz.com") {
        parseYouJizz();
        shouldListenOrientationChange = true;
    }
    else if (domain == "nuvid.com") {
        parseNuVid();
        shouldListenOrientationChange = true;
    }
    
    if (shouldListenOrientationChange == true) {
        window.addEventListener("orientationchange", handleTubesOrientationChange);
    }
 
}) ();
